Bug 1439328 - /usr/include/elf.h omits DF_1_STUB and DF_1_PIE
Summary: /usr/include/elf.h omits DF_1_STUB and DF_1_PIE
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Carlos O'Donell
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-04-05 17:39 UTC by John Reiser
Modified: 2018-01-15 17:03 UTC (History)
8 users (show)

Fixed In Version: glibc-2.26.9000-41.fc28
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-01-14 04:25:04 UTC
Type: Bug


Attachments (Terms of Use)

Description John Reiser 2017-04-05 17:39:54 UTC
Description of problem: /usr/include/elf.h lacks #define of DF_1_STUB and DF_1_PIE which are used by executables in /bin and /usr/bin, and reported by binutils-2.26/readelf --dynamic.


Version-Release number of selected component (if applicable):
glibc-headers-2.24-4.fc25.x86_64

How reproducible: every time


Steps to Reproduce:
1. grep DF_1_PIE /usr/include/elf.h
2.
3.

Actual results: empty (no line matches DF_1_PIE)



Expected results: as in binutils-2.26.1/include/elf/common.h:
#define DF_1_STUB       0x04000000
#define DF_1_PIE        0x08000000


Additional info: There may be other omissions, too.

Comment 1 Carlos O'Donell 2017-04-19 22:46:10 UTC
(In reply to John Reiser from comment #0)
> Expected results: as in binutils-2.26.1/include/elf/common.h:
> #define DF_1_STUB       0x04000000
> #define DF_1_PIE        0x08000000

This has to go upstream first.

Binutils elf/common.h and glibc's elf/elf.h should be in sync.

Comment 2 Fedora End Of Life 2017-11-16 19:33:13 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 3 John Reiser 2017-11-20 03:13:36 UTC
The problem persists in /usr/include/elf.h from
  glibc-headers-2.26-16.fc27.x86_64
which still lacks the definitions of DF_1_PIE and DF_1_STUB.

Comment 4 John Reiser 2018-01-13 14:59:02 UTC
The problem persists in /usr/include/elf.h from
  glibc-headers-2.26.9000-38.fc28.x86_64
which still lacks the definitions of DF_1_PIE and DF_1_STUB.

Comment #1 says "This has to go upstream first", and names binutils and glibc as the involved packages.  It seems to me that one of the maintainers of Fedora glibc is also a maintainer of GNU glibc.  Why has there been no progress in 9 months?

Comment 5 Carlos O'Donell 2018-01-14 04:25:04 UTC
(In reply to John Reiser from comment #4)
> The problem persists in /usr/include/elf.h from
>   glibc-headers-2.26.9000-38.fc28.x86_64
> which still lacks the definitions of DF_1_PIE and DF_1_STUB.
> 
> Comment #1 says "This has to go upstream first", and names binutils and
> glibc as the involved packages.  It seems to me that one of the maintainers
> of Fedora glibc is also a maintainer of GNU glibc.  Why has there been no
> progress in 9 months?

My apologies for the delay. 

This is now fixed upstream in glibc, and the next rawhide release will pull this fix in, and that means it will be in Fedora 28.

commit 505d39100454b38c62a8eff4c1b7c06b4a31f3aa (HEAD -> master, origin/master, origin/HEAD)
Author: Carlos O'Donell <carlos@redhat.com>
Date:   Sat Jan 13 20:21:57 2018 -0800

    Synchronize DF_1_* flags with binutils (Bug 22707)
    
    This patch synchronizes DF_1_* flags with binutils
    and ensures that all DF_1_* flags defined in binutil's
    include/elf/common.h are also defined glibc's elf/elf.h.
    This is a user visible change since elf/elf.h is installed
    by default as /usr/include/elf.h.
    
    Signed-off-by: Carlos O'Donell <carlos@redhat.com>

https://sourceware.org/bugzilla/show_bug.cgi?id=22707

In general when we review Fedora bugs we do so looking for issues that impact a wide number of users. This bug doesn't really meet that criteria, and therefore it depends on how easy it is to get change in upstream and if one of the Fedora glibc team members has time to send it upstream. In the last 9 months this bug simply hasn't met the criteria for being looked at. It lacks the priority for anyone to work on it.

In these cases it is helpful, particularly for technical submitters like yourself, to ping the bug and ask politely for a status update.

Thank you for your patience.


Note You need to log in before you can comment on or make changes to this bug.